from ..enums.IDType import *
from ..enums.ReleaseStages import *
from ..errors.InvalidEnum import InvalidEnum
from ..utils.methods import *

authKey = ''

def userMethods(key):
    global authKey

    authKey = key

class User():
    def __init__(self, id: str | int, type: idType = idType.RobloxUserId):
        url = 'v1/users/' + id

        match type:
            case idType.RobloxUserId:
                url += ''
            case idType.RobloxUsername:
                url += '?byname=true'
            case idType.DiscordUserId:
                url += '?bydsid=true'
            case _:
                raise InvalidEnum('''Invalid 'idType' enum provided.''')

        self.user = GET(url, authKey)['data']
    
    def getRobloxInfo(self):
        class RobloxInfo:
            user = self.user

            username = user['username']
            userId = user['userid']
        
        return RobloxInfo()
    
    def getDiscordData(self):
        user = self.user.has_key('discordtag') and self.user['discordtag'].split("#") or [ None, None ]

        class DiscordData:
            username = user[0]
            discriminator = user[1]
            id = self.user.has_key('discordid') and self.user['discordid'] or None
            verified = self.user['isvalidated']

        return DiscordData()
    
    def getGroupData(self):
        group = self.user['group']

        class GroupData:
            isMember = group['isingroup']
            rank = group['rank']

        return GroupData()
    
    def getStats(self):
        stats = self.user['stats']

        class Stats:
            wins = stats['win']
            losses = stats['lose']
            played = stats['played']
            scores = stats['score']
            credit = stats['credit']
            level = stats['level']
        
        return Stats()

    def isTerminated(self):
        return self.user['isbanned']

    def getStages(self):
        user = self.user
        stages = []

        if user['isalphaplayer']:
            list.append(stages, releaseStages.Alpha)

        if user['isbetaplayer']:
            list.append(stages, releaseStages.Beta)

        # if user['isreleasestage']:
        #    list.append(stages, releaseStages.Release)
        
        return stages
    
    def edit():
        #tbd

        print('not now sike')
    
    def delete(self):
        return DELETE('v1/users/' + str(self.user['userid']), authKey, {})